package k4unl.minecraft.pvpToggle.client;

import k4unl.minecraft.pvpToggle.PvpToggle;
import k4unl.minecraft.pvpToggle.api.PvPStatus;
import k4unl.minecraft.pvpToggle.lib.config.ModInfo;
import k4unl.minecraft.pvpToggle.lib.config.PvPConfig;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.Vec3;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.client.event.RenderPlayerEvent;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.opengl.GL11;

@SideOnly(Side.CLIENT)
public class ClientEventHandler {
    public static final ClientEventHandler instance = new ClientEventHandler();

    public static final ResourceLocation shield = new ResourceLocation(ModInfo.LID, "textures/gui/shield.png");
    public static final ResourceLocation lock   = new ResourceLocation(ModInfo.LID, "textures/gui/lock.png");
    public static final ResourceLocation sword  = new ResourceLocation(ModInfo.LID, "textures/gui/swords.png");

    public void renderTimeOverlay() {

    }

    @SubscribeEvent
    public void onRenderGameOverlay(RenderGameOverlayEvent event) {

        if ((event.type != RenderGameOverlayEvent.ElementType.EXPERIENCE && event.type != RenderGameOverlayEvent.ElementType.JUMPBAR) ||
          event.isCancelable()) {
            return;
        }
        if (!PvPConfig.INSTANCE.getBool("renderOwnIcon", "ui")) {
            return;
        }

        Minecraft mc = Minecraft.func_71410_x();

        GL11.glPushMatrix();
        GL11.glPushMatrix();

        //GL11.glColor3f(1.0F, 1.0F, 1.0F);
        //GL11.glDisable(GL11.GL_LIGHTING);
        //GL11.glEnable(GL11.GL_BLEND);

        //GL11.glEnable(GL11.GL_ALPHA_TEST);

        int x = PvPConfig.INSTANCE.getInt("x", "ui") - 3;
        int y = PvPConfig.INSTANCE.getInt("y", "ui") - 3;
        int w = 32;
        int h = 32;

        float zLevel = 0;

        Tessellator tessellator = Tessellator.func_178181_a();

        PvPStatus status = PvpToggle.clientPvPStatus.get(mc.field_71439_g.func_146103_bH().getName());

        if (status == null || status == PvPStatus.ON || status == PvPStatus.FORCEDON) {
            mc.func_110434_K().func_110577_a(sword);
        } else {
            mc.func_110434_K().func_110577_a(shield);
        }

        tessellator.func_178180_c().func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181707_g);
        tessellator.func_178180_c().func_181662_b((double) (x + 0), (double) (y + h), (double) zLevel).func_181673_a(0.0, 1.0).func_181675_d();
        tessellator.func_178180_c().func_181662_b((double) (x + w), (double) (y + h), (double) zLevel).func_181673_a(1.0, 1.0).func_181675_d();
        tessellator.func_178180_c().func_181662_b((double) (x + w), (double) (y + 0), (double) zLevel).func_181673_a(1.0, 0.0).func_181675_d();
        tessellator.func_178180_c().func_181662_b((double) (x + 0), (double) (y + 0), (double) zLevel).func_181673_a(0.0, 0.0).func_181675_d();
        tessellator.func_78381_a();

        if (status == PvPStatus.FORCEDON || status == PvPStatus.FORCEDOFF) {
            FMLClientHandler.instance().getClient().func_110434_K().func_110577_a(lock);

            tessellator.func_178180_c().func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181707_g);
            tessellator.func_178180_c().func_181662_b((double) (x + 0), (double) (y + h), (double) zLevel).func_181673_a(0.0, 1.0).func_181675_d();
            tessellator.func_178180_c().func_181662_b((double) (x + w), (double) (y + h), (double) zLevel).func_181673_a(1.0, 1.0).func_181675_d();
            tessellator.func_178180_c().func_181662_b((double) (x + w), (double) (y + 0), (double) zLevel).func_181673_a(1.0, 0.0).func_181675_d();
            tessellator.func_178180_c().func_181662_b((double) (x + 0), (double) (y + 0), (double) zLevel).func_181673_a(0.0, 0.0).func_181675_d();
            tessellator.func_78381_a();
        }

        //GL11.glEnable(GL11.GL_TEXTURE_2D);
        //GL11.glDisable(GL11.GL_BLEND);
        //GL11.glDisable(GL11.GL_ALPHA_TEST);

        //GL11.glEnable(GL11.GL_LIGHTING);
        GL11.glPopMatrix();
        GL11.glPopMatrix();

    }

    @SubscribeEvent
    public void onPlayerRender(RenderPlayerEvent.Post e) {

        if (!PvPConfig.INSTANCE.getBool("renderOtherIcon", "ui")) {
            return;
        }
        Minecraft mc = Minecraft.func_71410_x();

        float f = (20F - e.entity.func_70032_d(mc.field_71439_g)) / 1F;

        float alpha = MathHelper.func_76131_a(f, 0F, 1F);
        if (alpha == 0F) return;

        if (e.entityPlayer == mc.field_71439_g) return;

        GL11.glPushMatrix();
        GL11.glPushAttrib(GL11.GL_ENABLE_BIT);
        GL11.glEnable(GL11.GL_TEXTURE_2D);
        GL11.glDisable(GL11.GL_LIGHTING);
        GL11.glDisable(GL11.GL_CULL_FACE);
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        GL11.glColor4f(1F, 1F, 1F, alpha);
        //RenderPlayer

        double x = mc.field_71439_g.field_70169_q + (mc.field_71439_g.field_70165_t - mc.field_71439_g.field_70169_q) * e.partialRenderTick;
        double y = mc.field_71439_g.field_70167_r + (mc.field_71439_g.field_70163_u - mc.field_71439_g.field_70167_r) * e.partialRenderTick;
        double z = mc.field_71439_g.field_70166_s + (mc.field_71439_g.field_70161_v - mc.field_71439_g.field_70166_s) * e.partialRenderTick;
        Vec3 playerPos = new Vec3(x, y, z);

        x = e.entityPlayer.field_70169_q + (e.entityPlayer.field_70165_t - e.entityPlayer.field_70169_q) * e.partialRenderTick;
        y = e.entityPlayer.field_70167_r + (e.entityPlayer.field_70163_u - e.entityPlayer.field_70167_r) * e.partialRenderTick;
        z = e.entityPlayer.field_70166_s + (e.entityPlayer.field_70161_v - e.entityPlayer.field_70166_s) * e.partialRenderTick;
        Vec3 renderPos = new Vec3(x, y, z);

        GL11.glTranslated(renderPos.field_72450_a - playerPos.field_72450_a, renderPos.field_72448_b - playerPos.field_72448_b, renderPos.field_72449_c - playerPos.field_72449_c);
        GL11.glTranslated(0D, 2.5D, 0D);
        GL11.glRotatef(-Minecraft.func_71410_x().func_175598_ae().field_78735_i, 0F, 1F, 0F);
        GL11.glRotatef(Minecraft.func_71410_x().func_175598_ae().field_78732_j, 1F, 0F, 0F);
        GL11.glScalef(.5F, -.5F, -.5F);

        PvPStatus status = PvpToggle.clientPvPStatus.get(e.entityPlayer.func_146103_bH().getName());

        if (status == null || status == PvPStatus.ON || status == PvPStatus.FORCEDON) {
            mc.func_110434_K().func_110577_a(sword);
        } else {
            mc.func_110434_K().func_110577_a(shield);
        }

        GL11.glBegin(GL11.GL_QUADS);
        GL11.glTexCoord2f(0F, 0F);
        GL11.glVertex2f(-0.5F, -0.5F);
        GL11.glTexCoord2f(1F, 0F);
        GL11.glVertex2f(0.5F, -0.5F);
        GL11.glTexCoord2f(1F, 1F);
        GL11.glVertex2f(0.5F, 0.5F);
        GL11.glTexCoord2f(0F, 1F);
        GL11.glVertex2f(-0.5F, 0.5F);
        GL11.glEnd();

        if (status == PvPStatus.FORCEDON || status == PvPStatus.FORCEDOFF) {
            GL11.glTranslated(0D, 0D, 0.001D);

            mc.func_110434_K().func_110577_a(lock);
            GL11.glBegin(GL11.GL_QUADS);
            GL11.glTexCoord2f(0F, 0F);
            GL11.glVertex2f(-0.5F, -0.5F);
            GL11.glTexCoord2f(1F, 0F);
            GL11.glVertex2f(0.5F, -0.5F);
            GL11.glTexCoord2f(1F, 1F);
            GL11.glVertex2f(0.5F, 0.5F);
            GL11.glTexCoord2f(0F, 1F);
            GL11.glVertex2f(-0.5F, 0.5F);
            GL11.glEnd();
        }

        GL11.glPopAttrib();
        GL11.glPopMatrix();
    }
}
