package k4unl.minecraft.pvpToggle.events;

import k4unl.minecraft.pvpToggle.PvpToggle;
import k4unl.minecraft.pvpToggle.api.PvPStatus;
import k4unl.minecraft.pvpToggle.lib.*;
import k4unl.minecraft.pvpToggle.lib.config.PvPConfig;
import k4unl.minecraft.pvpToggle.network.packets.PacketPvPList;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.ChatComponentTranslation;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.world.World;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.util.FakePlayer;
import net.minecraftforge.event.entity.living.LivingAttackEvent;
import net.minecraftforge.event.entity.player.PlayerDropsEvent;
import net.minecraftforge.event.entity.player.PlayerEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent.PlayerChangedDimensionEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent.PlayerLoggedInEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;

import java.util.HashMap;
import java.util.List;

public class EventHelper {

    private int ticksPassed = 0;

    public static void init() {

        MinecraftForge.EVENT_BUS.register(new EventHelper());
    }

    @SubscribeEvent
    public void onLivingAttack(LivingAttackEvent event) {

        if (event.entityLiving instanceof EntityPlayer && event.source != null && event.source.func_76346_g() != null && event.source.func_76346_g() instanceof EntityPlayer && !(event.source.func_76346_g() instanceof FakePlayer)) {
            EntityPlayer player = (EntityPlayer) event.source.func_76346_g();
            if (Users.hasPVPEnabled(((EntityPlayer) event.source.func_76346_g()).func_70005_c_())) {
                if (!Users.hasPVPEnabled(((EntityPlayer) event.entityLiving).func_70005_c_())) {
                    event.setCanceled(true);
                    player.func_145747_a(new ChatComponentTranslation(EnumChatFormatting.RED + "Both players must have PvP enabled!"));
                }
            } else {
                event.setCanceled(true);
                player.func_145747_a(new ChatComponentTranslation(EnumChatFormatting.RED + "Both players must have PvP enabled!"));
            }
        }
    }


    @SubscribeEvent
    public void onPlayerDeath(PlayerDropsEvent event) {

        if (PvPConfig.INSTANCE.getBool("keepInventoryOnPVPDeath") || PvPConfig.INSTANCE.getBool("keepExperienceOnPVPDeath")) {
            if (event.source.func_76346_g() instanceof EntityPlayer && !(event.source.func_76346_g() instanceof FakePlayer)) {
                if (Users.hasPVPEnabled(((EntityPlayer) event.source.func_76346_g()).func_70005_c_())) {
                    if (Users.hasPVPEnabled(((EntityPlayer) event.entityLiving).func_70005_c_())) {

                        NBTTagCompound entityData = event.entityPlayer.getEntityData();

                        // PvP Kill
                        entityData.func_74757_a("killedByRealPlayer", true);

                        if (PvPConfig.INSTANCE.getBool("keepInventoryOnPVPDeath")) {
                            NBTTagList inventory = new NBTTagList();

                            for (int currentIndex = 0; currentIndex < event.drops.size(); ++currentIndex) {
                                NBTTagCompound itemTag = new NBTTagCompound();
                                event.drops.get(currentIndex).func_92059_d().func_77955_b(itemTag);
                                inventory.func_74742_a(itemTag);
                            }

                            entityData.func_74782_a("inventoryOnDeath", inventory);
                        }
                        if (PvPConfig.INSTANCE.getBool("keepExperienceOnPVPDeath")) {
                            entityData.func_74776_a("experienceOnDeath", event.entityPlayer.field_71106_cc);
                        }
                        event.setCanceled(true);
                    }
                }
            }
        }
    }

    @SubscribeEvent
    public void OnPlayerRespawn(PlayerEvent.Clone event) {

        if (event.wasDeath) {
            NBTTagCompound entityData = event.original.getEntityData();
            // Only repopulate if killed by real player
            if (entityData.func_74767_n("killedByRealPlayer")) {
                if (PvPConfig.INSTANCE.getBool("keepInventoryOnPVPDeath")) {
                    NBTTagList inventory = entityData.func_150295_c("inventoryOnDeath", 10);
                    for (int i = 0; i < inventory.func_74745_c(); i++) {
                        ItemStack created = ItemStack.func_77949_a(inventory.func_150305_b(i));
                        if (!event.entityPlayer.field_71071_by.func_70441_a(created)) {
                            EntityItem ei = new EntityItem(event.entityPlayer.func_130014_f_());
                            ei.func_92058_a(created);
                            ei.func_70107_b(event.entity.field_70176_ah, event.entity.field_70162_ai, event.entity.field_70164_aj);
                            event.entityPlayer.func_130014_f_().func_72838_d(ei);
                        }
                    }
                }
                if (PvPConfig.INSTANCE.getBool("keepExperienceOnPVPDeath")) {
                    event.entityPlayer.field_71106_cc = entityData.func_74760_g("experienceOnDeath");
                }
            }
        }
    }

    @SubscribeEvent
    public void loggedInEvent(PlayerLoggedInEvent event) {

        if (PvPConfig.INSTANCE.getBool("showMessageOnLogin")) {
            if (!MinecraftServer.func_71276_C().func_71218_a(event.player.field_71093_bK).field_72995_K) {
                if (Users.hasPVPEnabled(event.player.func_70005_c_())) {
                    event.player.func_145747_a(new ChatComponentText("PVPToggle is enabled on this server. You have PVP currently " + EnumChatFormatting
                      .RED + "Enabled"));
                } else {
                    event.player.func_145747_a(new ChatComponentText("PVPToggle is enabled on this server. You have PVP currently " + EnumChatFormatting
                      .GREEN + "Disabled"));
                }
            }
        }

        if (!MinecraftServer.func_71276_C().func_71218_a(event.player.field_71093_bK).field_72995_K) {
            PvpToggle.networkHandler.sendToDimension(Users.createPacket(event.player.func_146103_bH().getName()), event.player.field_71093_bK);

            //Send packet for all the users on the server
            PacketPvPList toSend = new PacketPvPList();
            for (EntityPlayer player : (List<EntityPlayer>) MinecraftServer.func_71276_C().func_71218_a(event.player.field_71093_bK).field_73010_i) {
                Users.addToPvpList(toSend, player.func_146103_bH().getName());
            }
            PvpToggle.networkHandler.sendTo(toSend, (EntityPlayerMP) event.player);
        }
    }

    @SubscribeEvent
    public void tickPlayer(TickEvent.PlayerTickEvent event) {

        if (event.phase == TickEvent.Phase.END) {
            if (event.side.isServer()) {
                Users.tickCoolDown();
            }
        }
    }

    @SubscribeEvent
    public void playerChangedDimension(PlayerChangedDimensionEvent event) {

        if (PvpToggle.instance.dimensionSettings.containsKey(event.toDim)) {
            if (!PvpToggle.instance.dimensionSettings.get(event.toDim).equals(PvPStatus.NOTFORCED)) {
                if (PvPConfig.INSTANCE.getBool("announceDimensionSetting")) {
                    event.player.func_145747_a(
                      new ChatComponentText(
                        "This dimension has PvP forced to " + (PvpToggle.instance.dimensionSettings.get(event.toDim).equals(PvPStatus.FORCEDON) ? "On" : "Off")));
                }
            }
            Users.getUserByName(event.player.func_146103_bH().getName()).setIsPvPForced(PvpToggle.instance.dimensionSettings.get(event.toDim));
            PvpToggle.networkHandler.sendToDimension(Users.createPacket(event.player.func_146103_bH().getName()), event.toDim);
        } else {
            //Remember his old setting.
            Users.getUserByName(event.player.func_146103_bH().getName()).setIsPvPForced(PvPStatus.OFF);
            PvpToggle.networkHandler.sendToDimension(Users.createPacket(event.player.func_146103_bH().getName()), event.toDim);
        }
        //And, send him all a packet from all the users in the dimension.
        PacketPvPList toSend = new PacketPvPList();
        for (EntityPlayer player : (List<EntityPlayer>) MinecraftServer.func_71276_C().func_71218_a(event.toDim).field_73010_i) {
            Users.addToPvpList(toSend, player.func_146103_bH().getName());
        }
        PvpToggle.networkHandler.sendTo(toSend, (EntityPlayerMP) event.player);

    }


    private HashMap<String, PvPArea>      players        = new HashMap<String, PvPArea>();
    private HashMap<String, EntityPlayer> playerEntities = new HashMap<String, EntityPlayer>();

    @SubscribeEvent
    public void serverTickEvent(TickEvent.ServerTickEvent event) {

        if (event.phase == TickEvent.Phase.END) {
            //Only check every so often
            ticksPassed++;
            if (ticksPassed == 10) {
                ticksPassed = 0;
                //Check all areas

                players = new HashMap<String, PvPArea>();
                playerEntities = new HashMap<String, EntityPlayer>();

                for (World world : MinecraftServer.func_71276_C().field_71305_c) {
                    for (EntityPlayer player : (List<EntityPlayer>) world.field_73010_i) {
                        playerEntities.put(player.func_146103_bH().getName(), player);
                        for (PvPArea area : Areas.getAreas()) {
                            if (area.contains((int) player.field_70165_t, (int) player.field_70163_u, (int) player.field_70161_v)) {
                                players.put(player.func_146103_bH().getName(), area);
                            }
                        }
                    }
                }

                for (User usr : Users.getUserList()) {
                    if (players.containsKey(usr.getUserName())) {
                        //Player is in an area
                        if (!usr.getIsInArea().equals(players.get(usr.getUserName()).getName())) {
                            //He just entered an area. Let's send packets etc.
                            //Log.info("Player " + usr.getUserName() + " just entered area " + players.get(usr.getUserName()).getName());
                            usr.setIsInArea(players.get(usr.getUserName()).getName());
                            usr.setIsPvPForced((players.get(usr.getUserName()).getForced() ? PvPStatus.FORCEDON : PvPStatus.FORCEDOFF));

                            if (players.get(usr.getUserName()).getAnnounce()) {
                                playerEntities.get(usr.getUserName()).func_145747_a(new ChatComponentText("You have entered area " + players.get(usr.getUserName()).getName() + ". Your PvP is forced to " + (players.get(
                                  usr.getUserName()).getForced() ? "On" : "Off")));
                            }

                            PvpToggle.networkHandler.sendToDimension(Users.createPacket(usr.getUserName()), playerEntities.get(usr.getUserName()).field_71093_bK);
                        }
                    } else if (playerEntities.containsKey(usr.getUserName())) {
                        if (usr == null) {
                            Log.error("NULL");
                        }
                        if (!usr.getIsInArea().equals("")) {
                            //He just left an area. Let's send packets etc.
                            //Log.info("Player " + usr.getUserName() + " just left area " + usr.getIsInArea());

                            //Now check if the dimension they're in requires a force:
                            int dimension = playerEntities.get(usr.getUserName()).field_71093_bK;
                            if (PvpToggle.instance.dimensionSettings.containsKey(dimension)) {
                                if (!PvpToggle.instance.dimensionSettings.get(dimension).equals(PvPStatus.NOTFORCED)) {
                                    usr.setIsPvPForced(PvpToggle.instance.dimensionSettings.get(dimension));
                                } else {
                                    usr.setIsPvPForced(PvPStatus.NOTFORCED);
                                }
                            } else {
                                usr.setIsPvPForced(PvPStatus.NOTFORCED);
                            }

                            if (Areas.getAreaByName(usr.getIsInArea()).getAnnounce()) {
                                if (usr.getPvpStatus().equals(PvPStatus.NOTFORCED)) {
                                    playerEntities.get(usr.getUserName()).func_145747_a(
                                      new ChatComponentText("You have left area " + usr.getIsInArea() + ". Your PvP is set to " + (usr.getPVP() ? "On" : "Off")));
                                } else {
                                    playerEntities.get(usr.getUserName()).func_145747_a(
                                      new ChatComponentText("You have left area " + usr.getIsInArea() + ". Your PvP is forced to " + (usr.getPvpStatus().equals(PvPStatus.FORCEDON) ? "On" : "Off")));
                                }
                            }

                            usr.setIsInArea("");

                            PvpToggle.networkHandler.sendToDimension(Users.createPacket(usr.getUserName()), playerEntities.get(usr.getUserName()).field_71093_bK);
                        }
                    } else {
                        //Player not logged in.
                    }
                }
            }
        }
    }
}

